'YModem data upload utility
'(C) 2008 Raymond Allen
' Free for non-commercial (except Prop-OLED Contest!) usage as long as this file and notice are not altered
' Not extensively tested!  Use at own risk!
'
CON  'Constants Section

  '_clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  '_xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency 

  'SD_Basepin=0  'basepin for SD card driver

  'Baudrate=115200    'baud rate for serial communications
  'RXPIN=31        'Prop pins used for comms
  'TXPIN=30

  'XMODEM chars from ymodem.txt
  SOH=$01
  STX=$02
  EOT=$04
  ACK=$06
  NAK=$15
  CAN=$18
  Cee=$43  'liberties here
  Zee=$1A  'or SUB  (DOS EOF?)

OBJ  'Objects Section

  ser : "FullDuplexSerial"  'for serial comms 
  num : "numbers"  'to format numbers 

var
   byte tbuf[20]
   byte stack[100]
   long Mounted
   byte sbuf[30]
   byte pdata[1028] 'packet data

PUB UploadData(pD,nBytes,sFilename,rxpin,txpin,baudRate)|cog,key,crc,i,z   


  num.init  'start numbers
  ser.start(RXPIN,TXPIN,0,BaudRate) 'open comm port


   'Establish serial link (wait for client to hit spacebar)
  key:=0
  repeat until key==32
    waitcnt(cnt+clkfreq)
    ser.str(string(27,"[2J Hit spacebar to begin.  "))',10,13))
    repeat 
      key:=ser.rxcheck
    while key>0 and key<>32
    
  'Show welcome logo
  ser.str(string(27,"[2J Welcome to the YModem Data transfer utility!",10,13))

  Waitkey(32,string(13,10,"Press spacebar to download data",13,10))
  receive(pD,nBytes,sFilename)

  

PUB receive(pD,nBytes,pfbuf)|key,i,size,seconds,timer,packet,d,crc,p,j,k,deot,n
  'Ymodem protocol: http://timeline.textfiles.com/1988/10/14/1/FILES/ymodem.txt
  '                 http://en.wikipedia.org/wiki/XMODEM
  
  ser.str(string(13,10,"Receive a file from data."))
  size:=nBytes
  ser.str(string(13,10,"Transmitting file.  Instruct terminal to receive YMODEM file now."))

  
  timer:=cnt
  key:=0
  'Wait for NAK from host:  Signal to start sending
  repeat until key==Cee
    i:=ser.rxcheck
    if i>0
      key:=i
    i:=cnt
    if ((cnt-timer)/clkfreq)>10           '10 second timeout
      ser.str(string(13,10,"Failure.  No response from host.."))
      return 'fail  

  
  'start sending packets
  packet:=0
  n:=0 'byte#
  repeat
    timer:=cnt
    crc:=0
    deot:=false  
    'send header
    ser.tx(SOH)
    ser.tx(packet)
    ser.tx(!packet)

    'construct packet
    if packet==0
      'Send filename and length
      i:=strsize(pfbuf)
      bytemove(@pdata,pfbuf,i+1)
      p:=num.tostr(size,num#DEC)
      j:=strsize(p)
      bytemove(@pdata+i+1,p,j+1)
      repeat k from i+1+j+1 to 128
        pdata[k]:=0
    else  
      'data packet
      repeat i from 0 to 127
        if n<nBytes
          d:=byte[pd][n++]'sdfat.pgetc
        else
          d:=-1
        if d==-1
          'end of file
          repeat i from i to 127
            d:=EOT'Zee
            pdata[i]:=d
            deot:=true
          quit          
        else
          if d<0 
            d:=EOT
            ser.tx(d)
            return 'fail      

        pdata[i]:=d

    'send packet
    repeat i from 0 to 127
      ser.tx(pdata[i])

      crc:=UpdateCRC(pdata[i],crc)
       

    ser.tx((crc>>8)&$FF)
    ser.tx(crc&$FF)
    

    repeat
      i:=ser.rxcheck
      if i==ACK
        quit
      if i==NAK
        'retransmit packet
        repeat i from 0 to 127
          ser.tx(pdata[i])
          ser.tx((crc>>8)&$FF)
          ser.tx(crc&$FF)
      if ((cnt-timer)/clkfreq)>10
        ser.tx(EOT)
        ser.str(string(13,10,"Timeout failure."))
        return 'fail
    if (deot==true)'Zee) 'done
      quit
    else
      packet++
      timer:=cnt
    

  'send EOT wait for ACK and send end of batch packet
  ser.tx(EOT)
  repeat
    i:=ser.rxcheck
    if i==ACK
      'now, wait for "C"
      timer:=cnt
      key:=0
      repeat until key==Cee
        i:=ser.rxcheck
        if i>0
          key:=i
        i:=cnt
        if ((cnt-timer)/clkfreq)>10           '10 second timeout
          ser.str(string(13,10,"Failure.  No response from host.."))
          return 'fail
      'now, transmit null packet and wait for ACK
      key:=0
      repeat until key==ACK
        ser.tx(SOH)
        ser.tx(0)
        ser.tx($FF)
        crc:=0
        repeat 128
          ser.tx(0)
          crc:=UpdateCRC(0,crc)
        ser.tx((crc>>8)&$FF)
        ser.tx(crc&$FF)
        'wait for ack
        key:=ser.rx
        if key<>ACK and key<>NAK
          return 'fail  
      quit  'all done!
    if i>0
      ser.tx(EOT)

  ser.str(string(13,10,"YModem data upload complete.",13,10))

    
      
    
PRI UpdateCRC(data,crc):newcrc|i,icrc
 'look here:http://web.mit.edu/6.115/www/miscfiles/amulet/amulet-help/xmodem.htm

  crc:=crc^(data<<8)
  repeat i from 0 to 7
    if crc&$8000
      crc:=((crc<<1)&$FFFF)^$1021
    else
      crc:=(crc<<=1)&$FFFF

  return crc&$FFFF


          
      
      
      

Pub Waitkey(k,str)|key  'show string and wait for key=k
  ser.str(str)
  key:=0
  repeat until key==k
    repeat 
      key:=ser.rxcheck
    while key>0 and key<>k   


Dat